searchNodes=[{"doc":"ShortUUID - generate concise, unambiguous, URL-safe UUIDs. Installation Add ShortUUID to your list of dependencies in mix.exs : def deps do [ { :shortuuid , &quot;~&gt; 3.0&quot; } ] end Usage The encode/1 function translates UUIDs to base57 using lowercase and uppercase letters, as well as digits, while ensuring that similar-looking characters such as 'l', '1', 'I', 'O', and '0' are avoided. iex&gt; ShortUUID . encode ( &quot;ed7ba470-8e54-465e-825c-99712043e01c&quot; ) { :ok , &quot;kGSmvLEEuzjcFZTChXwZpz&quot; } The decode/1 function will turn the ShortUUID back into a regular UUID iex&gt; ShortUUID . decode ( &quot;kGSmvLEEuzjcFZTChXwZpz&quot; ) { :ok , &quot;ed7ba470-8e54-465e-825c-99712043e01c&quot; } ShortUUID strives to do one thing well, encode UUIDs. To generate UUIDs use any UUID library of your choice. Some options: Ecto Elixir UUID Erlang UUID Notes ShortUUID supports the following input formats: 2a162ee5-02f4-4701-9e87-72762cbce5e2 2a162ee502f447019e8772762cbce5e2 Letter case is not relevant. Since version v2.1.0, ShortUUID also supports the encoding of binary UUIDs. iex&gt; ShortUUID . encode! ( &lt;&lt; 0xFA , 0x62 , 0xAF , 0x80 , 0xA8 , 0x61 , 0x45 , 0x6C , 0xAB , 0x77 , 0xD5 , 0x67 , 0x7E , 0x2E , 0x8B , 0xA8 &gt;&gt; ) &quot;nZJHSqgNVBBSX2h6sRUQuP&quot; Using ShortUUID with Ecto If you want to use ShortUUIDs with Ecto, you can explore the ecto_shortuuid library. Acknowledgments This project was inspired by skorokithakis/shortuuid .","ref":"ShortUUID.html","title":"ShortUUID","type":"module"},{"doc":"Decodes a ShortUUID string into a UUID.","ref":"ShortUUID.html#decode/1","title":"ShortUUID.decode/1","type":"function"},{"doc":"Decodes a ShortUUID string into a UUID. Raises an ArgumentError if the ShortUUID is invalid.","ref":"ShortUUID.html#decode!/1","title":"ShortUUID.decode!/1","type":"function"},{"doc":"Encodes a UUID into a ShortUUID string.","ref":"ShortUUID.html#encode/1","title":"ShortUUID.encode/1","type":"function"},{"doc":"Encodes a UUID into a ShortUUID string. Raises an ArgumentError if the UUID is invalid.","ref":"ShortUUID.html#encode!/1","title":"ShortUUID.encode!/1","type":"function"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Breaking change, ShortUUIDs created by &lt; v3.0.0 will produce bad results when decoded. The new output of encode is the reverse of the previous output. This follows a change in other languages ShortUUID libraries. To migrate ShortUUIDs created by &lt; v3.0.0 reverse them before passing to decode . # UUID &quot;00000001-0001-0001-0001-000000000001&quot; encoded using v2.1.2 to &quot;UD6ibhr3V4YXvriP822222&quot; # reversing the encoded string before decode with v3.0.0 will produce the correct result iex&gt; &quot;UD6ibhr3V4YXvriP822222&quot; |&gt; String . reverse ( ) |&gt; ShortUUID . decode! ( ) &quot;00000001-0001-0001-0001-000000000001&quot; Changed move most significant bit to the beginning of the encoded result similar to libraries in other languages (most importantly python shortuuid) drop support for decoding of un-padded ShortUUIDs drop support for formats other than regular hyphenated and unhyphenated UUIDs, MS format and binary UUIDs like are stored in PostgreSQL uuid type refactor code for better readability improve encode and decode performance Benchmarks Results are not comparable to previous benchmarks due to them being run on a different system Operating System : macOS CPU Information : Apple M2 Max Number of Available Cores : 12 Available memory : 32 GB Elixir 1.15 . 2 Erlang 25.3 . 2.3 Benchmark suite executing with the following configuration : warmup : 2 s time : 5 s memory time : 0 ns parallel : 1 inputs : none specified v3.0.0 Name ips average deviation median 99 th % encode / 1 binary uuid 1212.57 K 0.82 μs ± 1995.67 % 0.75 μs 1.00 μs encode / 1 unhyphenated uuid string 788.79 K 1.27 μs ± 984.70 % 1.13 μs 1.63 μs encode / 1 hyphenated uuid string 753.56 K 1.33 μs ± 1106.96 % 1.17 μs 1.67 μs encode / 1 uuid string with braces 722.36 K 1.38 μs ± 1188.51 % 1.21 μs 1.83 μs decode / 1 1.15 M 868.43 ns ± 1506.27 % 751 ns 1334 ns v2.1.1 Name ips average deviation median 99 th % encode / 1 binary uuid 1018.43 K 0.98 μs ± 1224.91 % 0.88 μs 1.25 μs encode / 1 unhyphenated uuid string 849.67 K 1.18 μs ± 1171.07 % 1.08 μs 1.42 μs encode / 1 hyphenated uuid string 731.91 K 1.37 μs ± 691.40 % 1.29 μs 1.63 μs encode / 1 uuid string with braces 569.16 K 1.76 μs ± 833.41 % 1.63 μs 2.17 μs decode / 1 1.00 M 996.37 ns ± 781.87 % 918 ns 1376 ns","ref":"changelog.html#v3-0-0-15-07-2023","title":"Changelog - v3.0.0 (15.07.2023)","type":"extras"},{"doc":"speed improvements Benchmarked on 2018 Macbook Pro 13 (non-touch), results are just a snapshot and not averaged. before: ## ShortUUIDBench benchmark name iterations average time encode / 1 uuid binary 500000 5.93 µs / op encode / 1 uuid string not hyphenated 100000 10.71 µs / op encode / 1 uuid string 100000 15.35 µs / op encode / 1 uuid string with braces 100000 17.22 µs / op decode / 1 100000 15.05 µs / op after: ## ShortUUIDBench benchmark name iterations average time encode / 1 uuid binary 500000 3.54 µs / op encode / 1 uuid string not hyphenated 500000 4.12 µs / op encode / 1 uuid string 500000 4.54 µs / op encode / 1 uuid string with braces 500000 5.84 µs / op decode / 1 500000 7.97 µs / op","ref":"changelog.html#v2-1-1-2019-02-18","title":"Changelog - v2.1.1 (2019-02-18)","type":"extras"},{"doc":"support directly encoding binary UUID","ref":"changelog.html#v2-1-0-2019-02-08","title":"Changelog - v2.1.0 (2019-02-08)","type":"extras"},{"doc":"add error fallbacks for encode/decode for the case where input is not string update test cases update docs","ref":"changelog.html#v2-0-1-2019-01-31","title":"Changelog - v2.0.1 (2019-01-31)","type":"extras"},{"doc":"drop support for custom alphabets use fixed alphabet 23456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz as it seems to be by far the most widely used shortuuid alphabet","ref":"changelog.html#v2-0-0-2019-01-29","title":"Changelog - v2.0.0 (2019-01-29)","type":"extras"},{"doc":"Copyright (c) 2019 Goran Pedić Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"ShortUUID is a lightweight Elixir library that generates short and unique IDs for use in URLs. It provides a solution when you need IDs that are easy to use and understand for users. Instead of using long and complex UUIDs, ShortUUID converts them into shorter strings using a combination of lowercase and uppercase letters, as well as digits. It avoids using similar-looking characters such as 'l', '1', 'I', 'O', and '0'. Note: It's worth noting that different ShortUUID implementations should work together if they use the same set of characters. However, there is no official standard, so if you plan to use ShortUUID with other libraries, it's a good idea to research and test for compatibility. Unlike some other libraries, ShortUUID doesn't generate UUIDs itself. Instead, you can input any valid UUID into the ShortUUID.encode/1 . To generate UUIDs, you can use libraries like Elixir UUID , Erlang UUID and also Ecto as it can generate version 4 UUIDs. ShortUUID supports common UUID formats and is case-insensitive. It also supports binary UUIDs returned from DBs like PostgreSQL when the uuid type is used to store the UUID.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Starting with version v3.0.0 , this library will follow suit with changes in other language implementations and move the most significant bit of the encoded value to the start. This also means that padding will be applied to the end of the string, not the start This change will restore compatibility with other libraries like shortuuid from v1.0.0 onwards and short-uuid . Before v3.0.0 iex&gt; &quot;00000001-0001-0001-0001-000000000001&quot; |&gt; ShortUUID . encode { :ok , &quot;UD6ibhr3V4YXvriP822222&quot; } After v3.0.0 iex&gt; &quot;00000001-0001-0001-0001-000000000001&quot; |&gt; ShortUUID . encode { :ok , &quot;222228PirvXY4V3rhbi6DU&quot; } To migrate ShortUUIDs created using &lt; v3.0.0 reverse them before passing to decode . # UUID &quot;00000001-0001-0001-0001-000000000001&quot; encoded using v2.1.2 to &quot;UD6ibhr3V4YXvriP822222&quot; # reversing the encoded string before decode with v3.0.0 will produce the correct result iex&gt; &quot;UD6ibhr3V4YXvriP822222&quot; |&gt; String . reverse ( ) |&gt; ShortUUID . decode! ( ) &quot;00000001-0001-0001-0001-000000000001&quot; Warning: Decoding ShortUUIDs created using a version &lt; v3.0.0 without reversing the string first will not fail but produce an incorrect result iex&gt; &quot;UD6ibhr3V4YXvriP822222&quot; |&gt; ShortUUID . decode! ( ) === &quot;00000001-0001-0001-0001-000000000001&quot; false iex&gt; &quot;UD6ibhr3V4YXvriP822222&quot; |&gt; ShortUUID . decode ( ) { :ok , &quot;933997ef-eb92-293f-b202-2a879fc84be9&quot; }","ref":"readme.html#compatibility","title":"Overview - Compatibility","type":"extras"},{"doc":"Add :shortuuid to your list of dependencies in mix.exs : def deps do [ { :shortuuid , &quot;~&gt; 3.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"iex&gt; &quot;f98e80e7-9923-4173-8408-98f8254912ad&quot; |&gt; ShortUUID . encode { :ok , &quot;nQtAWSRQ6ByybDtRs7dQwE&quot; } iex&gt; &quot;f98e80e7-9923-4173-8408-98f8254912ad&quot; |&gt; ShortUUID . encode! &quot;nQtAWSRQ6ByybDtRs7dQwE&quot; iex&gt; &quot;nQtAWSRQ6ByybDtRs7dQwE&quot; |&gt; ShortUUID . decode { :ok , &quot;f98e80e7-9923-4173-8408-98f8254912ad&quot; } iex&gt; &quot;nQtAWSRQ6ByybDtRs7dQwE&quot; |&gt; ShortUUID . decode! &quot;f98e80e7-9923-4173-8408-98f8254912ad&quot;","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"If you would like to use ShortUUID with Ecto schemas try Ecto.ShortUUID . It provides a custom Ecto type which allows for ShortUUID primary and foreign keys while staying compatible with :binary_key ( EctoUUID ).","ref":"readme.html#using-shortuuid-with-ecto","title":"Overview - Using ShortUUID with Ecto","type":"extras"},{"doc":"Look up the full documentation at https://hexdocs.pm/shortuuid .","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"Inspired by shortuuid .","ref":"readme.html#acknowledgments","title":"Overview - Acknowledgments","type":"extras"},{"doc":"Copyright (c) 2019 Goran Pedić This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]